<template>
  <Form
    class="mt-1"
    @submit="onSubmit"
    :validation-schema="schema"
    v-slot="{ meta, values, setErrors, submitForm }"
  >
    <b-row>
      <b-col cols="12" md="2">
        <div class="d-flex justify-content-center">
          <div class="image-placeholder">
            <template v-if="previewLogo">
              <img :src="previewLogo" alt="" />
              <div
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('logo')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewLogo">
              <div
                class="btn btn-icon rounded-circle img-add-btn"
                @click="$refs.companyLogo.click()"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="companyLogo"
              type="file"
              class="d-none"
              @input="uploadImage('logo')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Company Logo</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">160 x 40 px</p>
        <div class="d-flex justify-content-center mt-3">
          <div class="image-placeholder">
            <template v-if="previewMonoLogo">
              <img :src="previewMonoLogo" alt="" />
              <div
                class="btn btn-icon rounded-circle img-edit-btn"
                @click="removeImage('comapny_mono')"
              >
                <IconTrashImage />
              </div>
            </template>
            <div class="no_image" v-if="!previewMonoLogo">
              <div
                class="btn btn-icon rounded-circle img-add-btn"
                @click="$refs.comapnyMonoLogo.click()"
              >
                <IconPlusActive></IconPlusActive>
              </div>
            </div>
            <input
              ref="comapnyMonoLogo"
              type="file"
              class="d-none"
              @input="uploadImage('comapny_mono')"
            />
          </div>
        </div>
        <p class="image_title black-color mb-0">Add Company Mono</p>
        <p class="image-size-text">Recommended Size</p>
        <p class="image-size-text">40 x 40 px</p>
      </b-col>
      <b-col cols="12" md="10">
        <div class="card-with-shadow">
          <b-card class="form-card">
            <b-tabs>
              <!-- Tab: Account -->
              <b-tab active>
                <template #title>
                  <IconUsers class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Account</span>
                </template>
                <hr />
                <b-row>
                  <!-- Field: Username -->
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <TextInput
                        ref="firstInput"
                        name="company_name"
                        label="Company Name"
                        type="text"
                        placeholder="Enter Company Name"
                        :value="SettingModel.company_name"
                        :disabled="true"
                        :maxlength="30"
                        :autofocus="true"
                        @change="
                          (e) => {
                            createCompanyCode(e);
                            SettingModel.company_name = e;
                          }
                        "
                      >
                      </TextInput>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group label="Company Code" label-for="company_code">
                      <b-form-input
                        id="company_code"
                        v-model="SettingModel.company_code"
                        placeholder="Company Code"
                        :readonly="createNew ? false : true"
                        v-capitalize
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group label="Company ID" label-for="company_id">
                      <b-form-input
                        id="company_id"
                        readonly
                        v-model="SettingModel.company_id"
                        placeholder="Auto Generated"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group label="User ID" label-for="user_id">
                      <b-form-input
                        id="user_id"
                        readonly
                        v-model="SettingModel.user_id"
                        placeholder="Auto Generated"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <label class="d-block" for="username"
                        >User Name <span class="text-danger">*</span></label
                      >
                      <b-form-input
                        id="username"
                        disabled
                        v-model="SettingModel.username"
                        placeholder="Enter User Name"
                        v-capitalize
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <label class="d-block" for="email"
                        >Email ID <span class="text-danger">*</span></label
                      >
                      <b-form-input
                        id="email"
                        disabled
                        v-model="SettingModel.email"
                        placeholder="Enter Email ID"
                        class="text-transform-none"
                      />
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="6" class="">
                    <b-form-group>
                      <label class="d-block" for="phone_number"
                        >Phone Number <span class="text-danger">*</span></label
                      >
                      <b-row>
                        <b-col cols="12" md="4">
                          <v-select
                            class="eb-select"
                            disabled
                            v-model="SettingModel.country_code"
                            :options="phoneCodes"
                            :reduce="(val) => val.value"
                            :clearable="false"
                          />
                        </b-col>
                        <b-col cols="12" md="8">
                          <b-form-input
                            id="phone_number"
                            disabled
                            v-model="SettingModel.phone_number"
                            placeholder="Entr Phone Number"
                          />
                        </b-col>
                      </b-row>
                    </b-form-group>
                  </b-col>
                  <b-col cols="12" md="12" class="mb-2 px-0">
                    <div class="accordion collapse-icon collapse-default" role="tablist">
                      <b-card no-body class="overflow-visible fill-card p-0 pt-1">
                        <b-card-header
                          block
                          v-b-toggle="'accordion-1'"
                          header-tag="header"
                          class="pt-0 mr-3"
                          role="tab"
                          data-toggle="collapse"
                        >
                          <b-card-title
                            >Fill Additional
                            <span class="text-red">Information</span></b-card-title
                          >
                        </b-card-header>
                        <b-collapse
                          id="accordion-1"
                          accordion="my-accordion"
                          role="tabpanel"
                        >
                          <div class="w-100 d-block m-0 p-0">
                            <div class="mb-2">
                              <hr />
                            </div>
                            <!-- Additional Information -->
                            <b-row class="form-card inquiry-form mt-1 custom-form px-1">
                              <b-col cols="12" md="6" class="custom-date-picker">
                                <b-form-group label="Date of Birth" label-for="dob">
                                  <VDatePicker
                                    class="cursor-context-menu disabled p-0"
                                    :model-value="tempDate"
                                    @dayclick="dobSelected"
                                    title-position="left"
                                    :model-config="{
                                      type: 'string',
                                      mask: 'DD/MM/YYYY',
                                    }"
                                    trim-weeks
                                    :first-day-of-week="2"
                                    :masks="{
                                      weekdays: 'WWW',
                                      L: 'DD/MM/YYYY',
                                    }"
                                  >
                                    <template v-slot="{ inputValue, togglePopover }">
                                      <div class="flex items-center">
                                        <input
                                          :value="SettingModel.dob"
                                          class="custom-datepicker-input w-100 outline-none"
                                          :placeholder="'DD/MM/YYYY'"
                                          @click="togglePopover()"
                                        />
                                      </div>
                                    </template>
                                  </VDatePicker>
                                </b-form-group>
                              </b-col>
                            </b-row>
                            <b-row class="form-card inquiry-form mt-1 custom-form px-1">
                              <b-col cols="12" md="6" class="">
                                <b-form-group
                                  label="Address Line 1"
                                  label-for="address_one"
                                >
                                  <b-form-input
                                    id="address_one"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="SettingModel.address_one"
                                    placeholder="Enter Address Line 1"
                                    v-capitalize
                                    maxlength="100"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group
                                  label="Address Line 2"
                                  label-for="address_two"
                                >
                                  <b-form-input
                                    id="address_two"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="SettingModel.address_two"
                                    placeholder="Enter Address Line 2"
                                    v-capitalize
                                    maxlength="100"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="Postal Code" label-for="pin">
                                  <b-form-input
                                    id="pin"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="SettingModel.pin"
                                    placeholder="Enter Postal Code"
                                    maxlength="12"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="Area" label-for="area">
                                  <b-form-input
                                    id="area"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="SettingModel.area"
                                    placeholder="Enter Area"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="City" label-for="city">
                                  <b-form-input
                                    id="city"
                                    :state="errors.length > 0 ? false : null"
                                    v-model="SettingModel.city"
                                    placeholder="Enter City"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                  <small class="text-danger">{{ errors[0] }}</small>
                                </b-form-group>
                              </b-col>
                              <b-col cols="12" md="6" class="">
                                <b-form-group label="State / Province" label-for="state">
                                  <b-form-input
                                    id="state"
                                    v-model="SettingModel.state"
                                    placeholder="Enter State / Province"
                                    v-capitalize
                                    maxlength="50"
                                  />
                                </b-form-group>
                              </b-col>
                            </b-row>
                          </div>
                        </b-collapse>
                      </b-card>
                    </div>
                  </b-col>
                </b-row>
              </b-tab>
              <b-tab>
                <template #title>
                  <IconSettings class="profile-tab-icon" />
                  <span class="d-none d-sm-inline">Settings</span>
                </template>
                <hr />
                <b-row>
                  <b-col cols="10" md="10">
                    <table class="table table-borderless setting-table">
                      <tbody>
                        <tr>
                          <th>Settings Details</th>
                          <th class="text-center">Web</th>
                          <th class="text-center">Mobile</th>
                        </tr>
                        <tr>
                          <td>
                            <p class="mb-0">Login Based On OTP?</p>
                            <p class="note-text mb-0">
                              Note: Default Login is password based.
                            </p>
                          </td>
                          <td>
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="SettingModel.otp_based_login_web"
                                name="check-button"
                                inline
                                @change="
                                  checkBoxValueChange($event, 'otp_based_login_web')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                          <td>
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :disabled="pageType == 'view'"
                                :checked="SettingModel.otp_based_login_mobile"
                                name="check-button"
                                inline
                                @change="
                                  checkBoxValueChange($event, 'otp_based_login_mobile')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            SettingModel.otp_based_login_web ||
                            SettingModel.otp_based_login_mobile
                          "
                        >
                          <td>
                            <b-form-group>
                              <div class="demo-inline-spacing">
                                <b-form-checkbox
                                  id="otp_on_mail"
                                  :checked="SettingModel.otp_on_mail"
                                  name="otp_on_mail"
                                  class="my-0 custome-checkbox-lable-inline"
                                  @change="checkBoxValueChange($event, 'otp_on_mail')"
                                >
                                  OTP On Mail
                                </b-form-checkbox>
                                <b-form-checkbox
                                  id="otp_on_message"
                                  :checked="SettingModel.otp_on_message"
                                  name="otp_on_message"
                                  class="my-0 custome-checkbox-lable-inline"
                                  @change="checkBoxValueChange($event, 'otp_on_message')"
                                >
                                  OTP On Message
                                </b-form-checkbox>
                              </div>
                            </b-form-group>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>
                        <tr>
                          <td class="setting-td">
                            <p class="mb-0">Login Based On IP Restrication?</p>
                            <p class="note-text mb-0">
                              Note: Select if you want to restrict user login based on IP.
                            </p>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <CheckboxInput
                                :class="'custom-control custom-control-inline custom-checkbox'"
                                :isSwitch="false"
                                :disabled="pageType == 'view'"
                                :value="SettingModel.ip_based_login_web"
                                name="ip_based_login_web"
                                label=""
                                @change="
                                  checkBoxValueChange($event, 'ip_based_login_web')
                                "
                              ></CheckboxInput>
                            </b-form-group>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <CheckboxInput
                                :class="'custom-control custom-control-inline custom-checkbox'"
                                :disabled="pageType == 'view'"
                                :value="SettingModel.ip_based_login_mobile"
                                name="ip_based_login_mobile"
                                label=""
                                :isSwitch="false"
                                @change="
                                  checkBoxValueChange($event, 'ip_based_login_mobile')
                                "
                              ></CheckboxInput>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            SettingModel.ip_based_login_web ||
                            SettingModel.ip_based_login_mobile
                          "
                        >
                          <td>
                            <label>Permitted IP <span class="text-danger">*</span></label>
                            <SelectTagInput
                              class="ip-box"
                              :disabled="pageType == 'view'"
                              v-model="SettingModel.ip_options"
                              name="ip_options"
                              placeholder="Add IPs"
                            ></SelectTagInput>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>
                        <tr>
                          <td class="setting-td">
                            <p class="mb-0">Auto Logout User?</p>
                            <p class="note-text mb-0">
                              Note: If you want user to auto logout daily.
                            </p>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :checked="SettingModel.auto_logout_web"
                                name="check-button"
                                inline
                                @change="checkBoxValueChange($event, 'auto_logout_web')"
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                          <td class="setting-td">
                            <b-form-group class="text-center">
                              <b-form-checkbox
                                :checked="SettingModel.auto_logout_mobile"
                                name="check-button"
                                inline
                                @change="
                                  checkBoxValueChange($event, 'auto_logout_mobile')
                                "
                              >
                              </b-form-checkbox>
                            </b-form-group>
                          </td>
                        </tr>
                        <tr
                          v-if="
                            SettingModel.auto_logout_web ||
                            SettingModel.auto_logout_mobile
                          "
                        >
                          <td>
                            <label>Auto Logout Time</label>
                            <b-form-group class="auto-logout-group">
                              <b-input-group
                                label="Auto Logout At"
                                label-for="auto_logout_at"
                                class="auto_logout_at"
                                :append="this.logoutTimeZone"
                              >
                                <b-form-timepicker
                                  :hour12="false"
                                  v-model="SettingModel.auto_logout_at"
                                  locale="en"
                                />
                              </b-input-group>
                            </b-form-group>
                          </td>
                          <td></td>
                          <td></td>
                        </tr>
                        <tr>
                          <td class="setting-td">
                            <p class="mt-1 mb-0">Max Password Wrong Attempt</p>
                            <p class="note-text mb-0">
                              Note: Min 5 and Max 25 you can set.
                            </p>
                          </td>
                        </tr>
                        <tr>
                          <td>
                            <b-form-input
                              id="password_max_attempt"
                              v-model="SettingModel.password_max_attempt"
                              :state="errors.length > 0 ? false : null"
                              placeholder="Max Attempt"
                              maxlength="2"
                              class="password_max_attempt"
                              v-on:keypress="isNumber($event)"
                            />
                          </td>
                        </tr>
                      </tbody>
                    </table>
                  </b-col>
                </b-row>
              </b-tab>
            </b-tabs>
          </b-card>
        </div>
        <b-row class="mt-2">
          <b-col cols="12" md="12" class="px-4 text-right">
            <b-button
              class="btn-reset"
              variant="flat-secondary"
              type="button"
              @click.prevent="getModelData"
            >
              Reset
            </b-button>
            <b-button
              class="btn-submit-edit mr-1"
              variant="primary"
              type="submit"
              @click="saveForm(false)"
            >
              <b-spinner small v-if="isSubmit" />
              Save
            </b-button>
            <b-button
              class="three-btn-spacer btn-submit-edit"
              variant="primary"
              type="submit"
              @click="saveForm(true)"
              :disabled="isSubmit"
            >
              <b-spinner small v-if="isSubmit" />
              Save & Apply All
            </b-button>
          </b-col>
        </b-row>
      </b-col>
    </b-row>
  </Form>
</template>
<script>
import {
  BImg,
  BCard,
  BTab,
  BTabs,
  BRow,
  BCol,
  BAlert,
  BFormInput,
  BButton,
  BTable,
  BMedia,
  BAvatar,
  BLink,
  BBadge,
  BDropdown,
  BDropdownItem,
  BPagination,
  BFormGroup,
  BForm,
  BCardHeader,
  BCardBody,
  BCardFooter,
  BCardTitle,
  BFormCheckbox,
  BFormRadioGroup,
  BFormCheckboxGroup,
  BDropdownForm,
  BFormTimepicker,
  BFormFile,
  BInputGroup,
  BSpinner,
  BCollapse,
  VBToggle,
} from "bootstrap-vue";
import vSelect from "vue-select";
import store from "@/store";
import Ripple from "vue-ripple-directive";
import { ref, onUnmounted, computed } from "vue";
import settingsService from "./service";
import SettingModel from "./model/settings";
import router from "@/router";
import flatPickr from "vue-flatpickr-component";
import moment from "moment";
import { useToast } from "vue-toastification";
const toast = useToast();
import ToastificationContent from "@core/components/toastification/ToastificationContent.vue";
import * as yup from "yup";
import { Form, useForm, ErrorMessage, Field } from "vee-validate";
import "moment-timezone";
import timeZone from "@/timeZone.json";

export default {
  components: {
    Form,
    BTab,
    BImg,
    BTabs,
    BCard,
    BRow,
    BCol,
    BAlert,
    BFormInput,
    BButton,
    BTable,
    BMedia,
    BAvatar,
    BLink,
    BBadge,
    BDropdown,
    BDropdownItem,
    BPagination,
    vSelect,
    BFormGroup,
    BForm,
    BCardHeader,
    BCardTitle,
    BFormCheckbox,
    BCardBody,
    BCardFooter,
    flatPickr,
    BFormRadioGroup,
    BFormCheckboxGroup,
    BDropdownForm,
    BFormTimepicker,
    BFormFile,
    BInputGroup,
    BSpinner,
    // VDatePicker,
    BCollapse,
    VBToggle,
  },
  setup() {
    const MODULE_NAME = "settings";
    // Register module

    if (!store.hasModule(MODULE_NAME)) store.registerModule(MODULE_NAME, settingsService);
    // UnRegister on leave
    onUnmounted(() => {
      // if (store.hasModule(MODULE_NAME)) store.unregisterModule(MODULE_NAME);
    });

    return {};
  },
  data() {
    let tempDate = "";
    return {
      tempDate,
      errors: [],
      isSubmit: false,
      SettingModel,
      addAdditionDetails: false,
      createNew: true,
      designationOptions: [],
      roleOptions: [],
      permissionOptions: [],
      selected: [],
      ipOptions: [],
      phoneCodes: [],
      currentLogo: "",
      previewLogo: "",
      currentMonoLogo: "",
      previewMonoLogo: "",
      currentCompanyMono: "",
      previewCompanyMono: "",
      currentProfiePhoto: "",
      previewProfiePhoto: "",
      previewSignaturePhoto: "",
      saveAndApplyAll: false,
      dpconfig: {
        dateFormat: "d/m/Y",
      },
      logoutTimeZone: "UTC",
    };
  },
  directives: {
    Ripple,
    "b-toggle": VBToggle,
  },
  computed: {
    accordion() {
      return this.$parent.accordion ? `accordion-${this.$parent.collapseID}` : null;
    },
    schema() {
      return yup.object().shape({
        ip_based_login_mobile: yup.boolean(),
        ip_based_login_web: yup.boolean(),
        ip_options: yup
          .array("Please enter Permitted IP")
          .when(["ip_based_login_mobile", "ip_based_login_web"], {
            is: (ip_based_login_mobile, ip_based_login_web) => {
              return ip_based_login_mobile || ip_based_login_web;
            },
            then: (schema) => schema.min(1, "Please enter Permitted IP").of(yup.string()),
            otherwise: (schema) => schema,
          }),
      });
    },
  },
  mounted() {
    var systemTimeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
    if (timeZone[systemTimeZone] != undefined) {
      this.logoutTimeZone = timeZone[systemTimeZone];
    } else {
      this.logoutTimeZone = systemTimeZone;
    }
    this.getModelData();
  },
  methods: {
    saveForm(type) {
      this.saveAndApplyAll = type;
    },
    // onSubmitAll(values, setErrors, meta, submitForm, e) {
    //   if (meta && meta.valid) {
    //     this.saveAndApplyAll = true;
    //     this.onSubmit(values, { setErrors });
    //   } else {
    //     submitForm(e);
    //   }
    // },
    onSubmit(values, { setErrors }) {
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      this.isSubmit = true;
      let formData = new FormData();
      formData.append("is_logo", this.previewLogo);
      formData.append("is_mono_logo", this.previewMonoLogo);
      formData.append("logo", this.currentLogo);
      formData.append("mono_logo", this.currentMonoLogo);
      formData.append("is_profile", this.previewProfiePhoto);
      formData.append("is_signature", this.previewSignaturePhoto);
      formData.append("company_name", SettingModel.company_name);
      formData.append("company_code", SettingModel.company_code);
      formData.append("username", SettingModel.username);
      formData.append("email", SettingModel.email);
      formData.append("country_code", SettingModel.country_code);
      formData.append("phone_number", SettingModel.phone_number);
      formData.append("dob", SettingModel.dob);
      formData.append("address_one", SettingModel.address_one);
      formData.append("address_two", SettingModel.address_two);
      formData.append("area", SettingModel.area);
      formData.append("city", SettingModel.city);
      formData.append("state", SettingModel.state);
      formData.append("pin", SettingModel.pin);
      formData.append("ip_options", values.ip_options ? values.ip_options : "");
      formData.append("ip_based_login_web", values.ip_based_login_web);
      formData.append("ip_based_login_mobile", values.ip_based_login_mobile);
      formData.append("otp_based_login_web", SettingModel.otp_based_login_web);
      formData.append("otp_based_login_mobile", SettingModel.otp_based_login_mobile);
      formData.append("auto_logout_web", SettingModel.auto_logout_web);
      formData.append("auto_logout_mobile", SettingModel.auto_logout_mobile);
      formData.append("otp_on_mail", SettingModel.otp_on_mail);
      formData.append("otp_on_message", SettingModel.otp_on_message);
      formData.append("password_max_attempt", SettingModel.password_max_attempt);
      formData.append("save_and_appply_all", this.saveAndApplyAll);
      formData.append(
        "auto_logout_at",
        this.time_convert(1, SettingModel.auto_logout_at)
      );
      formData.append("password_otp_on_mail", SettingModel.password_otp_on_mail);
      formData.append("hide_transaction", JSON.stringify(SettingModel.hide_transaction));
      formData.append("require_approval", JSON.stringify(SettingModel.require_approval));
      formData.append("password_otp_on_message", SettingModel.password_otp_on_message);
      formData.append("status", SettingModel.status);
      if (this.SettingModel.id) {
        formData.append("id", this.SettingModel.id);
      }
      store
        .dispatch("settings/save", formData)
        .then((response) => {
          if (response.data.status == true) {
            this.showToast(
              "success",
              "CheckCircleIcon",
              response.data.title,
              response.data.message
            );
            this.isSubmit = false;
            localStorage.setItem("userData", JSON.stringify(response.data.result));
            const newUserData = JSON.parse(localStorage.getItem("userData"));
            store.commit("appConfig/UPDATE_COMPNAY_MONO", {
              mono: newUserData.company.mono_logo
                ? import.meta.env.VITE_API_URL + newUserData.company.mono_logo
                : "",
            });
            store.commit("appConfig/UPDATE_COMPNAY_LOGO", {
              logo: newUserData.company.logo
                ? import.meta.env.VITE_API_URL + newUserData.company.logo
                : "",
            });
            // window.location.reload();
          } else {
            if (response.data.errors) {
              setErrors(response.data.errors);
            } else {
              this.showToast(
                "danger",
                "AlertCircleIcon",
                response.data.title,
                response.data.message
              );
            }
            this.isSubmit = false;
          }
          appLoading.style.display = "none";
        })
        .catch(() => {
          this.isSubmit = false;
          appLoading.style.display = "none";
        });
    },
    validationForm() {
      // this.$refs.addEditFormRules.validate().then((success) => {
      if (true) {
      }
      // });
    },
    dobSelected(e) {
      let selectedDate =
        ("0" + e.day).slice(-2) + "/" + ("0" + e.month).slice(-2) + "/" + e.year;
      let tempDate =
        ("0" + e.month).slice(-2) + "/" + ("0" + e.day).slice(-2) + "/" + e.year;
      if (selectedDate == this.SettingModel.dob) {
        this.SettingModel.dob = "";
        this.tempDate = "";
      } else {
        this.SettingModel.dob = selectedDate;
        this.tempDate = tempDate;
      }
    },
    passwordOtpChange(e, type) {
      if (type == "password_otp_on_mail") {
        this.SettingModel.password_otp_on_mail = e;
        if (e == false) {
          this.SettingModel.password_otp_on_message = true;
        }
      }
      if (type == "password_otp_on_message") {
        this.SettingModel.password_otp_on_message = e;
        if (e == false) {
          this.SettingModel.password_otp_on_mail = true;
        }
      }
    },
    checkBoxValueChange(e, type) {
      if (type == "status") {
        this.SettingModel.status = e;
      }
      if (type == "ip_based_login_web") {
        this.SettingModel.ip_based_login_web = e;
      }
      if (type == "ip_based_login_mobile") {
        this.SettingModel.ip_based_login_mobile = e;
      }
      if (type == "otp_based_login_web") {
        this.SettingModel.otp_based_login_web = e;
        if (this.SettingModel.otp_based_login_web == true) {
          this.SettingModel.otp_on_mail = true;
        }
      }

      if (type == "otp_based_login_mobile") {
        this.SettingModel.otp_based_login_mobile = e;
        if (this.SettingModel.otp_based_login_mobile == true) {
          this.SettingModel.otp_on_mail = true;
        }
      }

      if (type == "auto_logout_web") {
        this.SettingModel.auto_logout_web = e;
      }
      if (type == "auto_logout_mobile") {
        this.SettingModel.auto_logout_mobile = e;
      }

      if (type == "otp_on_mail") {
        this.SettingModel.otp_on_mail = e;
      }
      if (type == "otp_on_message") {
        this.SettingModel.otp_on_message = e;
      }
      if (type == "otp_on_mail" || type == "otp_on_message") {
        if (
          this.SettingModel.otp_on_mail == true ||
          this.SettingModel.otp_on_message == true
        ) {
          if (
            this.SettingModel.otp_based_login_mobile == true ||
            this.SettingModel.otp_based_login_web == true
          ) {
          } else {
            this.SettingModel.otp_based_login_web = true;
            this.SettingModel.otp_based_login_mobile = true;
          }
        } else {
          if (
            this.SettingModel.otp_on_mail == false &&
            this.SettingModel.otp_on_message == false
          ) {
            this.SettingModel.otp_based_login_web = false;
            this.SettingModel.otp_based_login_mobile = false;
          }
        }
      }
    },
    removeImage(type) {
      if (type == "comapny_mono") {
        this.$refs.comapnyMonoLogo.value = null;
        this.currentMonoLogo = "";
        this.previewMonoLogo = "";
      }
      if (type == "logo") {
        this.$refs.companyLogo.value = null;
        this.currentLogo = "";
        this.previewLogo = "";
      }
    },
    uploadImage(type) {
      if (type == "logo") {
        this.currentLogo = this.$refs.companyLogo.files.item(0);
        this.previewLogo = URL.createObjectURL(this.currentLogo);
      }
      if (type == "comapny_mono") {
        this.currentMonoLogo = this.$refs.comapnyMonoLogo.files.item(0);
        this.previewMonoLogo = URL.createObjectURL(this.currentMonoLogo);
      }
      if (type == "profile") {
        this.currentProfiePhoto = this.$refs.profilePhoto.files.item(0);
        this.previewProfiePhoto = URL.createObjectURL(this.currentProfiePhoto);
      }
    },
    createCompanyCode(val) {
      if (this.createNew == true) {
        val = val.substr(0, 4);
        SettingModel.company_code = val;
      }
    },
    showToast(variant, icon, title, message) {
      toast({
        component: ToastificationContent,
        props: {
          title: title,
          icon: variant == "success" ? "CheckCircleIcon" : "AlertCircleIcon",
          text: message,
          variant: variant,
        },
      });
    },
    getModelData() {
      store
        .dispatch("settings/countryCode")
        .then((response) => {
          this.phoneCodes = response.data.result;
        })
        .catch(() => {});
      const appLoading = document.getElementById("loading-bg");
      if (appLoading) {
        appLoading.style.display = "block";
      }
      store
        .dispatch("settings/settings")
        .then((response) => {
          this.createNew = false;
          const data = response.data.result;
          this.SettingModel.id = data.id;
          this.SettingModel.company_id = data.company_id;
          this.SettingModel.company_name = data.name;
          this.SettingModel.company_code = data.company_code;
          this.SettingModel.country_code = data.country_code;
          this.SettingModel.phone_number = data.phone_number;
          this.SettingModel.address_one = data.address_one ? data.address_one : "";
          this.SettingModel.address_two = data.address_two ? data.address_two : "";
          this.SettingModel.area = data.area ? data.area : "";
          this.SettingModel.city = data.city ? data.city : "";
          this.SettingModel.state = data.state ? data.state : "";
          this.SettingModel.pin = data.pin ? data.pin : "";

          this.SettingModel.ip_based_login_mobile =
            data.ip_based_login_mobile == 1 ? true : false;
          this.SettingModel.ip_based_login_web =
            data.ip_based_login_web == 1 ? true : false;
          this.SettingModel.otp_based_login_mobile =
            data.otp_based_login_mobile == 1 ? true : false;
          this.SettingModel.otp_based_login_web =
            data.otp_based_login_web == 1 ? true : false;
          this.SettingModel.auto_logout_mobile =
            data.auto_logout_mobile == 1 ? true : false;
          this.SettingModel.auto_logout_web = data.auto_logout_web == 1 ? true : false;
          this.SettingModel.otp_on_mail = data.otp_on_mail == 1 ? true : false;
          this.SettingModel.otp_on_message = data.otp_on_message == 1 ? true : false;
          this.SettingModel.password_otp_on_mail =
            data.password_otp_on_mail == 1 ? true : false;
          this.SettingModel.password_otp_on_message =
            data.password_otp_on_message == 1 ? true : false;
          this.SettingModel.status = data.status == 1 ? true : false;
          this.SettingModel.ip_options = data.ip_options ? data.ip_options : "";
          this.SettingModel.password_max_attempt = data.password_max_attempt;
          if (data.auto_logout_at != "00:00:00") {
            this.SettingModel.auto_logout_at = this.time_convert(2, data.auto_logout_at);
          } else {
            this.SettingModel.auto_logout_at = "00:00";
          }
          let parseHide = JSON.parse(data.hide_transaction);
          if (parseHide != null) {
            this.SettingModel.hide_transaction = parseHide;
          }
          let parseApproval = JSON.parse(data.require_approval);
          if (parseApproval != null) {
            this.SettingModel.require_approval = parseApproval;
          }
          if (data.user) {
            const user = data.user;
            this.SettingModel.user_id = user.user_id;
            this.SettingModel.username = user.name;
            this.SettingModel.email = user.email;
            this.SettingModel.dob = user.dob ? moment(user.dob).format("DD/MM/YYYY") : "";
            this.tempDate = user.dob;
          }
          if (data.logo) {
            this.previewLogo = import.meta.env.VITE_API_URL + data.logo;
          } else {
            this.previewLogo = "";
          }
          if (data.mono_logo) {
            this.previewMonoLogo = import.meta.env.VITE_API_URL + data.mono_logo;
          } else {
            this.previewMonoLogo = "";
          }
          if (data.profile) {
            this.previewProfiePhoto = import.meta.env.VITE_API_URL + data.profile;
          }
          if (data.signature) {
            this.previewSignaturePhoto = import.meta.env.VITE_API_URL + data.signature;
          }
          appLoading.style.display = "none";
        })
        .catch((error) => {
          appLoading.style.display = "none";
        });
    },
    time_convert(type, time) {
      if (type == 1) {
        var customTime = new Date("2023-07-14T" + time);
        var timeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        const Time = moment.tz(customTime, timeZone).utc().format("HH:mm:ss");
        return Time;
      }
      if (type == 2) {
        var utc = new Date("2023-07-13T" + time + "Z");
        var timeZone = Intl.DateTimeFormat().resolvedOptions().timeZone;
        return moment.utc(utc).tz(timeZone).format("HH:mm:ss");
      }
    },
    isNumber(e) {
      let char = String.fromCharCode(e.keyCode); // Get the character
      var ctrlKey = 17,
        cmdKey = 91,
        vKey = 86,
        cKey = 67,
        bSpace = 8;
      if (
        e.keyCode == vKey ||
        e.keyCode == cKey ||
        e.keyCode == ctrlKey ||
        e.keyCode == cmdKey
      ) {
        e.preventDefault();
      } else if (/^[0-9]+$/.test(char) || e.keyCode == bSpace) {
        return true; // Match with regex
      } else {
        e.preventDefault(); // If not match, don't add to input text
      }
    },
  },
};
</script>

<style lang="scss" scoped>
.per-page-selector {
  width: 90px;
}

.export-checkbox label {
  display: block;
  float: left;
  padding-top: 4px;
}
</style>

<style lang="scss">
// @import "~@resources/scss/vue/libs/vue-select.scss";
// @import "~@resources/scss/vue/libs/vue-flatpicker.scss";
.three-btn-spacer {
  min-width: 180px;
}
</style>
